<?startSampleFile ?>
<!-- xq255.xsl: converts xq254.xml into xq256.txt -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:red="http://www.snee.com/red"
                xmlns:blau="http://www.snee.com/blue"
                version="1.0">
<xsl:output method="text"/>

  <xsl:template match="poem">
   Namespace nodes:
    <xsl:for-each select="namespace::*"> 
      <xsl:value-of select="name()"/><xsl:text> </xsl:text>
    </xsl:for-each>
    <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="blau:verse">
   Found a blue verse.
	 name          <xsl:value-of select="name()"/>
	 local-name    <xsl:value-of select="local-name()"/>
	 namespace-uri <xsl:value-of select="namespace-uri()"/>
	 contents      <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="red:*">
   Found a red node:
	 name          <xsl:value-of select="name(.)"/>
	 local-name    <xsl:value-of select="local-name(.)"/>
	 namespace-uri <xsl:value-of select="namespace-uri(.)"/>
	 contents      <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="verse">
   Found a verse element from the default namespace:
	 name          <xsl:value-of select="name(.)"/>
	 local-name    <xsl:value-of select="local-name(.)"/>
	 namespace-uri <xsl:value-of select="namespace-uri(.)"/>
	 contents      <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="*"/>

</xsl:stylesheet>
<?endSampleFile ?>

