<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
     version="1.0">
<xsl:output method="text"/>
<?startSampleFile u25b.xsl ?>
<!-- xq286.xsl: converts xq285.xml into xq287.txt -->

<xsl:template match="poem">

  --- Start of "if" tests. ---

  <xsl:if test="@author='jm'">
    1. The poem's author is jm.
  </xsl:if>

  <xsl:if test="@author">
    2. The poem has an author attribute.
  </xsl:if>

  <xsl:if test="@flavor">
    3. The poem has a flavor attribute.
  </xsl:if>

  <xsl:if test="verse">
    4. The poem has at least one verse child element.
  </xsl:if>

  <xsl:if test="shipDate">
    5. The poem has at least one shipDate child element.
  </xsl:if>

  <xsl:if test="count(verse) > 3">
    6. The poem has more than 3 verse child elements.
  </xsl:if>

  <xsl:if test="count(verse) &lt; 3">
    7. The poem has less than 3 verse child elements.
  </xsl:if>

  <xsl:if test="(@author = 'bd') or (@year='1667')">
    8. Either the author is "bd" or the year is "1667".
  </xsl:if>

  <xsl:if test="@year &lt; '1850'">
    9a. The poem is old.

    <xsl:if test="@year &lt; '1700'">
      9b. The poem is very old.
    </xsl:if>

    <xsl:if test="@year &lt; '1500'">
      9c. The poem is very, very old.
    </xsl:if>

  </xsl:if>

  --- End of "if" tests. 

</xsl:template>
<?endSampleFile ?>
</xsl:stylesheet>
