<?startSampleFile ?>
<!-- xq465.xsl: converts xq463.xml into xq466.html -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
     version="1.0">

  <xsl:output method="html"/>

  <xsl:template match="chapter">
    <html><body>

      <!-- Generate a list of picture titles, with each 
           title linking to the picture in the poem below. -->
      <b>Pictures:</b><br/>
      <xsl:for-each select="descendant::figure">
        <a href="#{generate-id(graphic)}">
        <xsl:value-of select="title"/></a><br/>
    </xsl:for-each>

    <xsl:apply-templates/>
    </body></html>
  </xsl:template>


  <xsl:template match="para">
    <p><xsl:apply-templates/></p>
  </xsl:template>


  <xsl:template match="graphic">
    <!-- Image and title as caption, centered. -->
    <center><a name="{generate-id(.)}"><img src="{@fileref}"/></a>
    <b><xsl:value-of select="../title"/></b></center>
  </xsl:template>


  <!-- Suppress figure title because "graphic" template
       rule already added it to result tree. -->
  <xsl:template match="figure/title"/>


</xsl:stylesheet>
<?endSampleFile ?>

